;=============================================
;
        LIST    p=16F84
       __CONFIG 03FF1H
;=============================================
                                   ;  
                                   ;    1  255
T1          equ       .67          ; 
T2          equ       .221         ; 
                                   ; (  4000 kHz)
;=============================================
;
IndF        equ        00h         ;     FSR
Timer0      equ        01h         ; TMR0
OptionR     equ        01h         ; Option (RP0=1)
PC          equ        02h         ;  
Status      equ        03h         ; Status
FSR         equ        04h         ;   
PortA       equ        05h         ; Port A
TrisA       equ        05h         ; Tris A - RP0=1
PortB       equ        06h         ; Port B
TrisB       equ        06h         ; Tris B - RP0=1
EEData      equ        08h         ; EEPROM Data
EECon1      equ        08h         ; EECON1 - RP0=1
EEAdr       equ        09h         ; EEPROM Address
EECon2      equ        09h         ; EECON2 - RP0=1
IntCon      equ        0Bh         ;
;                                     
W           equ        0           ; 
F           equ        1           ; 
; Flag bits:
CF          equ        0           ; Carry
DC          equ        1           ; DC
ZF          equ        2           ; Zero
RP0         equ        5

	CBLOCK .12
KeyBuf		;  
KeyWait	       	;  
Count		;  
Count1		;  
LED0
LED1
LED2
LED3
LED4
LED5
LED6
LED7
TimerL
TimerM
TimerH
IF_L
IF_M
IF_H
Temp
LEDIndex
			ENDC
;
;=============================================
;
            org        0
            goto    Start
;
;
;=============================================
;  BCD -> 7  
;=============================================

LCDTable
            addwf      PC,F        ; W + PC -> PC
            retlw      b'00111111' ; ..FEDCBA = '0'
            retlw      b'00000110' ; .....CB. = '1'
            retlw      b'01011011' ; .G.ED.BA = '2'
            retlw      b'01001111' ; .G..DCBA = '3'
            retlw      b'01100110' ; .GF..CB. = '4'
            retlw      b'01101101' ; .GF.DC.A = '5'
            retlw      b'01111101' ; .GFEDC.A = '6'
            retlw      b'00000111' ; .....CBA = '7'
            retlw      b'01111111' ; .GFEDCBA = '8'
            retlw      b'01101111' ; .GF.DCBA = '9'
            retlw      b'01110001' ; .GFE...A = 'F'
;
;=============================================
;Main program
;=============================================
Start
            bsf        Status,RP0

            movlw      b'00010000' ; RA0..RA3 outputs
            movwf      TrisA       ; RA4 input

            movlw      b'00000000' ; RB0..RB7 outputs
            movwf      TrisB
            movlw      b'00100111' ; Prescaler -> Timer0,
            movwf      OptionR     ; 1:256,   
            bcf        Status,RP0  ;

            clrf       Count       ; 
            clrf       LEDIndex

            clrf       LED0        ; 
            clrf       LED1
            clrf       LED2
            clrf       LED3
            clrf       LED4
            clrf       LED5
            clrf       LED6
            clrf       LED7
            movlw      .0 
            movwf      LED0
            movlw      .1 
            movwf      LED1
            movlw      .2 
            movwf      LED2
            movlw      .3 
            movwf      LED3
            movlw      .4 
            movwf      LED4
            movlw      .5 
            movwf      LED5
            movlw      .6 
            movwf      LED6
            movlw      .7 
            movwf      LED7

            clrf       TimerL      ;  
            clrf       TimerM
            clrf       TimerH

;
;=============================================
; 6-step cycle of digits -   
;=============================================
;
LEDCycle    movlw      LED0
            addwf      LEDIndex,W  ; LED1 + LEDIndex -> W

            movwf      FSR         ; W -> FSR
            movf       IndF,W      ; LED(0..6) -> W
            call       LCDTable    ; W ->  

            movwf      Temp        ;  ?
            movlw      .5
            bsf        Status,ZF
            subwf      LEDIndex,W
            btfss      Status,ZF
            goto       NoDot
            bsf        Temp,.7
NoDot       movf       Temp,W
            movwf      PortB       ;    PortB

            movf       LEDIndex,W  ; LEDIndex -> W
            movwf      PortA       ;    PortA
;
;=============================================
; The first timing loop
;=============================================
O_K
	            movlw      .1
	            movwf      Count1
EndPause	            movlw      .255
	            movwf      Count
Pause
	decfsz     Count,F
	goto       Pause
;
	decfsz     Count1,F
	goto       EndPause
	 nop

;=============================================
;
            incf       LEDIndex,F
            movlw      .6           ; is 6th?
            bcf        Status,ZF
            subwf      LEDIndex,W
            btfss      Status,ZF
            goto       LEDCycle    ; . 
            nop
;
            clrf       LEDIndex
            goto       LEDCycle    ; next 6xLED
;
            end
